// This sample demonstrates drag-n-drop capability between GUI components.
// -Chris North, Virginia Tech

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DragnDrop
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.ListBox listBox2;
		private System.Windows.Forms.TextBox textBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.listBox2 = new System.Windows.Forms.ListBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Items.AddRange(new object[] {
														  "Drag from here",
														  "listbox",
														  "hello",
														  "world",
														  "dude",
														  "lots of interesting",
														  "text here",
														  "stuff to select",
														  "and ",
														  "drag to other boxes",
														  "neato"});
			this.listBox1.Location = new System.Drawing.Point(24, 24);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(112, 199);
			this.listBox1.TabIndex = 0;
			this.listBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseDown);
			// 
			// listBox2
			// 
			this.listBox2.AllowDrop = true;
			this.listBox2.Items.AddRange(new object[] {
														  "Or drop it here",
														  "listbox",
														  "can drop it",
														  "anywhere in here",
														  "to position it",
														  "where you ",
														  "want it"});
			this.listBox2.Location = new System.Drawing.Point(208, 64);
			this.listBox2.Name = "listBox2";
			this.listBox2.Size = new System.Drawing.Size(120, 160);
			this.listBox2.TabIndex = 1;
			this.listBox2.DragDrop += new System.Windows.Forms.DragEventHandler(this.listBox2_DragDrop);
			this.listBox2.DragEnter += new System.Windows.Forms.DragEventHandler(this.listBox2_DragEnter);
			// 
			// textBox1
			// 
			this.textBox1.AllowDrop = true;
			this.textBox1.Location = new System.Drawing.Point(208, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(120, 20);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "Drop it here";
			this.textBox1.DragDrop += new System.Windows.Forms.DragEventHandler(this.textBox1_DragDrop);
			this.textBox1.DragEnter += new System.Windows.Forms.DragEventHandler(this.textBox1_DragEnter);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 261);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.listBox2);
			this.Controls.Add(this.listBox1);
			this.Name = "Form1";
			this.Text = "Drag-n-Drop Demo";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void listBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			// When user clicks down on item in listbox1, initiate the dragndrop process:
			// send text of selected item as data to transfer
			this.DoDragDrop(listBox1.Items[listBox1.SelectedIndex], DragDropEffects.Copy);
		}

		private void textBox1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// notify that we can recieve dragndrop:
			e.Effect = DragDropEffects.Copy;
		}

		private void textBox1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// user dropped it on us, get the transferred text data:
			textBox1.Text = (String)e.Data.GetData(typeof(System.String));
		}

		private void listBox2_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// notify that we can recieve dragndrop:
			e.Effect = DragDropEffects.Copy;
		}

		private void listBox2_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// user dropped it on us.  calculate where drop point occured in the list:
			int i = listBox2.IndexFromPoint(listBox2.PointToClient(new Point(e.X,e.Y)));
			if(i >= 0)	// insert transfered text data at that point in the list:
				listBox2.Items.Insert(i, e.Data.GetData(typeof(String)));
			else	// or just append it on the end:
				listBox2.Items.Add(e.Data.GetData(typeof(String)));
		}
	}
}
